import dataclasses


@dataclasses.dataclass
class ELogData:

    printer: str

    to_print: bool = None

    author: str = None
    title: str = None
    severity: str = None
    text: str = None
    image: str = None

    def get_e_log_entry(self):
        # list header
        e_log_xml_string_list = list(["<?xml version=\"1.0\" encoding=\"ISO-8859-1\"?>"])
        # list beginning
        e_log_xml_string_list.append("<entry>")
        # author information
        e_log_xml_string_list.append("<author>")
        e_log_xml_string_list.append(self.author)
        e_log_xml_string_list.append("</author>")
        # title information
        e_log_xml_string_list.append("<title>")
        e_log_xml_string_list.append(self.title)
        e_log_xml_string_list.append("</title>")
        # severity information
        e_log_xml_string_list.append("<severity>")
        e_log_xml_string_list.append(self.severity)
        e_log_xml_string_list.append("</severity>")
        # text information
        e_log_xml_string_list.append("<text>")
        e_log_xml_string_list.append(self.text.replace("<", "&lt;").replace(">", "&gt;"))
        e_log_xml_string_list.append("</text>")
        # image information
        e_log_xml_string_list.append("<image>")
        e_log_xml_string_list.append(self.image)
        e_log_xml_string_list.append("</image>")
        # list end
        e_log_xml_string_list.append("</entry>")
        # return the joined list as the final string
        return "\n".join(e_log_xml_string_list).encode()
