from PyQt5.QtCore import QTimer


class ConcurrencyService:

    _TIMER = QTimer()
    _METHOD = None

    @classmethod
    def start(cls, method):
        if cls._METHOD is None:
            cls._METHOD = method
            cls._TIMER.timeout.connect(method)
            cls._TIMER.start(0)

    @classmethod
    def stop(cls):
        if cls._METHOD is not None:
            cls._TIMER.stop()
            cls._TIMER.timeout.disconnect(cls._METHOD)
            cls._METHOD = None
