import subprocess


class ELogService:

    def __init__(self, e_log_data):
        self._e_log_data = e_log_data

    @property
    def e_log_data(self):
        return self._e_log_data

    def update_e_log_data_image(self, screenshot):
        self._e_log_data.image = screenshot

    def print(self):
        if self._e_log_data.to_print:
            with subprocess.Popen(["/usr/bin/lp", "-o", "raw", "-d", self._e_log_data.printer],
                                  stdin=subprocess.PIPE, stdout=subprocess.PIPE, stderr=subprocess.PIPE) as printer:
                _, stderr = printer.communicate(self._e_log_data.get_e_log_entry())
                if stderr:
                    raise Exception(stderr.decode())
