from .print_tool_ui import PrintToolUi


class PrintTool:

    def __init__(self, e_log_data, default_author, version):
        self._print_tool_ui = PrintToolUi("To be printed to: " + e_log_data.printer, default_author)
        self._e_log_data = e_log_data
        self._version = version
        self._create_connections()

    def _create_connections(self):
        self._print_tool_ui.print_button.clicked.connect(self._print_button_clicked)
        self._print_tool_ui.cancel_button.clicked.connect(self._cancel_button_clicked)

    def _print_button_clicked(self):
        self._e_log_data.to_print = True
        self._e_log_data.author = self._print_tool_ui.author_line_edit.text()
        self._e_log_data.title = self._print_tool_ui.title_line_edit.text()
        self._e_log_data.severity = self._print_tool_ui.severity_combo_box.currentText()
        self._e_log_data.text = self._print_tool_ui.text_edit.toPlainText() + "\n----Version " + self._version
        self._print_tool_ui.close()

    def _cancel_button_clicked(self):
        self._print_tool_ui.close()

    def show_standard_dialog(self):
        self._e_log_data.to_print = False
        self._print_tool_ui.show_window()
        self._print_tool_ui.exec()

    def show_error_dialog(self, exception_name, message):
        self._print_tool_ui.title_line_edit.setText(exception_name)
        self._print_tool_ui.severity_combo_box.setCurrentText(PrintToolUi.FATAL)
        self._print_tool_ui.text_edit.setText(message)
        self.show_standard_dialog()
